// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2014.1
// Copyright (C) 2014 Xilinx Inc. All rights reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="deinterleave_samples,hls_ip_2014_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=1,HLS_INPUT_PART=xc6slx9tqg144-2,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=0.000000,HLS_SYN_LAT=-1,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=0,HLS_SYN_LUT=0}" *)

module deinterleave_samples (
        ap_clk,
        ap_rst,
        input_V_V_dout,
        input_V_V_empty_n,
        input_V_V_read,
        output_V_V_din,
        output_V_V_full_n,
        output_V_V_write
);

parameter    ap_const_logic_1 = 1'b1;
parameter    ap_const_logic_0 = 1'b0;
parameter    ap_ST_st1_fsm_0 = 2'b00;
parameter    ap_ST_st2_fsm_1 = 2'b1;
parameter    ap_ST_st3_fsm_2 = 2'b10;
parameter    ap_const_lv32_10 = 32'b10000;
parameter    ap_const_lv32_1F = 32'b11111;
parameter    ap_true = 1'b1;

input   ap_clk;
input   ap_rst;
input  [31:0] input_V_V_dout;
input   input_V_V_empty_n;
output   input_V_V_read;
output  [15:0] output_V_V_din;
input   output_V_V_full_n;
output   output_V_V_write;

reg input_V_V_read;
reg[15:0] output_V_V_din;
reg output_V_V_write;
reg   [15:0] tmp_V_1_reg_69;
reg   [1:0] ap_CS_fsm = 2'b00;
reg    ap_sig_bdd_25;
wire   [15:0] tmp_V_fu_54_p1;
reg   [1:0] ap_NS_fsm;




/// the current state (ap_CS_fsm) of the state machine. ///
always @ (posedge ap_clk)
begin : ap_ret_ap_CS_fsm
    if (ap_rst == 1'b1) begin
        ap_CS_fsm <= ap_ST_st1_fsm_0;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

/// assign process. ///
always @(posedge ap_clk)
begin
    if (((ap_ST_st2_fsm_1 == ap_CS_fsm) & ~ap_sig_bdd_25)) begin
        tmp_V_1_reg_69 <= {{input_V_V_dout[ap_const_lv32_1F : ap_const_lv32_10]}};
    end
end

/// input_V_V_read assign process. ///
always @ (ap_CS_fsm or ap_sig_bdd_25)
begin
    if (((ap_ST_st2_fsm_1 == ap_CS_fsm) & ~ap_sig_bdd_25)) begin
        input_V_V_read = ap_const_logic_1;
    end else begin
        input_V_V_read = ap_const_logic_0;
    end
end

/// output_V_V_din assign process. ///
always @ (output_V_V_full_n or tmp_V_1_reg_69 or ap_CS_fsm or ap_sig_bdd_25 or tmp_V_fu_54_p1)
begin
    if (((ap_ST_st3_fsm_2 == ap_CS_fsm) & ~(output_V_V_full_n == ap_const_logic_0))) begin
        output_V_V_din = tmp_V_1_reg_69;
    end else if (((ap_ST_st2_fsm_1 == ap_CS_fsm) & ~ap_sig_bdd_25)) begin
        output_V_V_din = tmp_V_fu_54_p1;
    end else begin
        output_V_V_din = 'bx;
    end
end

/// output_V_V_write assign process. ///
always @ (output_V_V_full_n or ap_CS_fsm or ap_sig_bdd_25)
begin
    if ((((ap_ST_st2_fsm_1 == ap_CS_fsm) & ~ap_sig_bdd_25) | ((ap_ST_st3_fsm_2 == ap_CS_fsm) & ~(output_V_V_full_n == ap_const_logic_0)))) begin
        output_V_V_write = ap_const_logic_1;
    end else begin
        output_V_V_write = ap_const_logic_0;
    end
end
always @ (output_V_V_full_n or ap_CS_fsm or ap_sig_bdd_25)
begin
    case (ap_CS_fsm)
        ap_ST_st1_fsm_0 : 
            ap_NS_fsm = ap_ST_st2_fsm_1;
        ap_ST_st2_fsm_1 : 
            if (~ap_sig_bdd_25) begin
                ap_NS_fsm = ap_ST_st3_fsm_2;
            end else begin
                ap_NS_fsm = ap_ST_st2_fsm_1;
            end
        ap_ST_st3_fsm_2 : 
            if (~(output_V_V_full_n == ap_const_logic_0)) begin
                ap_NS_fsm = ap_ST_st2_fsm_1;
            end else begin
                ap_NS_fsm = ap_ST_st3_fsm_2;
            end
        default : 
            ap_NS_fsm = 'bx;
    endcase
end

/// ap_sig_bdd_25 assign process. ///
always @ (input_V_V_empty_n or output_V_V_full_n)
begin
    ap_sig_bdd_25 = ((input_V_V_empty_n == ap_const_logic_0) | (output_V_V_full_n == ap_const_logic_0));
end
assign tmp_V_fu_54_p1 = input_V_V_dout[15:0];


endmodule //deinterleave_samples

